#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#
#  This Datapack was generated for private distribution only  #
# ----------------------------------------------------------- #
#                         DATAPACK INFO                       #
# ----------------------------------------------------------- #
#     Author: GenMode                                         #
#     Twitter: @DatapackGen                                   #
#     URL: https://github.com/GenMode/Minecraft/wiki          #
#                                                             #
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%#


# Init
execute as @s[tag=!temp.better_babies.init] \
    run function better_babies:entity/remove
$execute as @s[tag=!temp.better_babies.init] \
    run summon $(type) ~ ~ ~ {\
        Age:-5000, \
        active_effects: [{id:"minecraft:invisibility", amplifier:false, duration:-1, show_particles:false}], \
        Tags: $(Tags)}
$execute unless entity @e[type=#minecraft:display_entities, tag=temp.better_babies.init] at @s \
    run summon minecraft:item_display ~ ~ ~ {\
        Tags: ["data.entity", "entity.better_babies.model", "temp.better_babies.init"], \
        transformation: $(transformation)}

# Custom Data
$data modify entity @n[type=#minecraft:display_entities, tag=temp.better_babies.init] item set value {\
    id:"$(item)", \
    components: {"minecraft:item_model":"$(model)", "minecraft:item_name":'{"translate":"$(name)"}'}}
$execute as @n[type=#minecraft:display_entities, tag=temp.better_babies.init] run \
    data modify entity @s item.components."minecraft:custom_data".custom_entity_data set value {\
        animations: $(animations), \
        mobstates: $(mobstates)}
execute as @n[type=#minecraft:display_entities, tag=temp.better_babies.init] \
    if data entity @s item{id:"minecraft:leather_horse_armor"} \
    run data modify entity @s \
        item.components."minecraft:custom_data".custom_entity_data.track_color set \
        value true

# Close
tellraw @s[type=minecraft:player] [\
    {"text":"","color":"light_purple"}, \
    {"translate":"Summoned new"}, {"text":" "}, \
    {"selector":"@n[type=!#minecraft:display_entities, tag=temp.better_babies.init]"}]
ride @n[type=#minecraft:display_entities, tag=temp.better_babies.init] \
    mount @n[type=!#minecraft:display_entities, tag=temp.better_babies.init]
tag @e remove temp.better_babies.init
